#*************************************************************
# Progamm 			fluisa_wlgl_stat_2d_quelle
# Sinn des Programms: 		Löser der Wärmeleitungsgl.
# Sinn der Einheit  :		Aufstellung der Koeffizientenmatrix
# Name der Datei    :		rand_bed.py
# Versionsnummer:		1
# Wird aufgerufen von:		fluisa_wlgl_stat_2d_quelle_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	4
# von:				7
# Autor: 			Armin Ulrich
# Erster Lauf: 			22.10.2021
# Letzte Änderung: 		08.09.2022
#*************************************************************

#*************************************************************
# Import der Klasse os zum Bearbeiten von Dateien
#*************************************************************
import os
import numpy as np

#*************************************************************
# Klassendefinition Koeffizientenmatrix
#*************************************************************
class Rand_bed:
  #Konstruktormethode
  def __init__(self):		
    print("Randbedingungsobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("Randbedingungsobjekt entfernt")   
    
#*************************************************************
# Funktion zum Einlesen der Randbedingungen
#*************************************************************
  def rand_bed_input(self,rand_datei, m_gitter,n_gitter):
    self.rückgabeliste = list(range(2))
    self.rückgabeliste[0] = True                                 # Einlesen der Randbedingungen korrekt            True/False
    self.rückgabeliste[1] = "Randdatei wurde korrekt gelesen"    # Fehlermeldung für Einlesen der Randbedingungen  Text  
    print("Einlesen der Randbedingungen")    
    print("Name der Randbedingungs_datei:",rand_datei)
    rückgabe_wert = True
    if os.path.exists(rand_datei):
      print("Datei ist vorhanden",m_gitter,n_gitter)

      fobj_in = open(rand_datei,"r") 
      
      zeile=fobj_in.readline()
      self.puffer = zeile[:-1]
      dummy = self.puffer.split("\t")      
      m = int(dummy[0])
      n = int(dummy[1])   
      if m == m_gitter and n == n_gitter:   

      
        self.rand_art_west = list(range(n))
        self.rand_art_ost = list(range(n))
        self.rand_art_süd = list(range(m))
        self.rand_art_nord = list(range(m))
        self.rand_wert_west = np.zeros((n))
        self.rand_wert_ost = np.zeros((n))
        self.rand_wert_süd = np.zeros((m))
        self.rand_wert_nord = np.zeros((m))
            
        zeile=fobj_in.readline()
        self.puffer = zeile[:-1]

        for j in range(n): 
          zeile=fobj_in.readline()
          self.puffer = zeile[:-1]
          dummy = self.puffer.split("\t")
          self.rand_art_west[j]=dummy[0]
          self.rand_wert_west[j]=(dummy[1])
        zeile=fobj_in.readline()
        self.puffer = zeile[:-1]

        for j in range(n): 
          zeile=fobj_in.readline()
          self.puffer = zeile[:-1]
          dummy = self.puffer.split("\t")
          self.rand_art_ost[j]=dummy[0]
          self.rand_wert_ost[j]=(dummy[1])        
        zeile=fobj_in.readline()
        self.puffer = zeile[:-1]

        for i in range(m): 
          zeile=fobj_in.readline()
          self.puffer = zeile[:-1]
          dummy = self.puffer.split("\t")
          self.rand_art_süd[i]=dummy[0]
          self.rand_wert_süd[i]=(dummy[1])
        zeile=fobj_in.readline()
        self.puffer = zeile[:-1]

        for i in range(m): 
          zeile=fobj_in.readline()
          self.puffer = zeile[:-1]
          dummy = self.puffer.split("\t")
          self.rand_art_nord[i]=dummy[0]
          self.rand_wert_nord[i]=(dummy[1])         

        fobj_in.close()
      else:
        print("Gitter nicht kompatibel mit den Randbedingungen")
        self.rückgabeliste[0] = False
        self.rückgabeliste[1] = "Gitter nicht kompatibel mit den Randbedingungen"
    else:
      print("Datei ist NICHT vorhanden")
      self.rückgabeliste[0] = False
      self.rückgabeliste[1] = "Randdatei nicht vorhanden"
    return self.rückgabeliste[0] 
